﻿using XF.Domain.Dependency;

namespace Hotline.Settings
{
    public class SystemAreaDomainService : ISystemAreaDomainService, IScopeDependency
    {
        private readonly ISystemAreaRepository _systemAreaRepository;

        public SystemAreaDomainService(ISystemAreaRepository systemAreaRepository)
        {
            _systemAreaRepository = systemAreaRepository;
        }

        public async Task AddArea(SystemArea model, CancellationToken cancellationToken)
        {
            await _systemAreaRepository.AddAsync(model,cancellationToken);
        }

        public async Task ModifyArea(SystemArea model, CancellationToken cancellationToken)
        {
            await _systemAreaRepository.UpdateAsync(model,cancellationToken);
        }

        public async Task<List<SystemArea>> GetAreaTree()
        {
           return await  _systemAreaRepository.Queryable().ToTreeAsync(x => x.Children,q=>q.ParentId, "");
        }

        public async Task<SystemArea?> GetArea(string id, CancellationToken cancellationToken)
        {
            return await _systemAreaRepository.GetAsync(id,cancellationToken);
        }

        public async Task DelArea(string id,CancellationToken cancellationToken)
        {
            await _systemAreaRepository.RemoveAsync(id, true, cancellationToken);
        }
    }
}
